;Include "GRIG_MAP_4x12.bb"
Include "F_Gruppa.bb"
;Include "F_Strela.bb"
Include "F_Gorod.bb"
Include "F_ViborPlemeni.bb"

Type ButtonsGame
	; Bx[0] By[0] -    , Bx[1] By[1] - \  , Bnum - , Bname -   , Bakt -    
	Field Bx#[1] , By#[1] , Bnum% , Bname$ , Bakt% , Bimage 
End Type 

Global BG_.ButtonsGame   Dim bg.ButtonsGame(25)

Global GameOver = False
Global hitdoublespeed% = 300  , b = -1 	
Global Screen%=0 
Global mx# , my# 
Global frmSparks ,SelId , vibor%=1

Graphics 800,600,32,2 
SetBuffer BackBuffer() 
HidePointer
SeedRnd MilliSecs()

Type ListData
	Field xposList#, yposList#, animframeList%, speedList#
End Type

Global 	CreateList.ListData


Global	Star 			= LoadAnimImage("images/Stars_.bmp",9,9,0,8) 	: MaskImage Star ,0,0,0
Global      Start_Fon 	= LoadImage("images/Elf_hunter.jpg")
Global 	Start_Menu 	= LoadImage("images/Start_Menu.bmp") 		: MaskImage Start_Menu,0,0,0
;Global 	Gorod_Elf  	= LoadImage("images/gorod_elf.bmp") 			: MaskImage Gorod_Elf,0,0,0
Global      Cursor  		= LoadImage("images/Cursor2.jpg")			: MaskImage Cursor  ,0,0,0	
Global      Vcursor = LoadImage ("images\ViborCursor.bmp") : MaskImage Vcursor ,0,0,0
;Global      Cursor_game 	= LoadImage("images/Cursor_game.bmp")		: MaskImage Cursor  ,0,0,0
;Global 	Elf_Edinorog 	= LoadImage("images/elf_Edinorog.bmp")  		: MaskImage  Elf_Edinorog ,0,0,0
;Global 	Gorod_Efov 	= LoadImage("images/Elf_Big_Tree.jpg")  		: MaskImage  Gorod_Efov ,0,0,0
;Global      Vihod 		= LoadImage("images/vihod.bmp")				: MaskImage  Vihod ,0,0,0



IntroScreen()

While Not KeyHit(1) 
	SetBuffer BackBuffer() 
	Cls
	mx# = MouseX() :  my# = MouseY()	
	
	If GameOver = True Then
		FlushMouse
		FlushKeys 
	;	GameoverScreen()
		IntroScreen()
		GameOver = False
		Screen = 0
	Else	


	Select Screen
			
	Case 0
			ChoisePlemea()
	Case 1
			IntroGorod()
	Case 2
;			IntroGorod()
;	Case 3		
;			Battle()
	Case 9000
			GameOver = True 
	End Select 
	
	If KeyHit(59) Then GameOver = True 
	DrawImage Vcursor  ,mx#,my#
	
	Flip
	EndIf
Wend 
TerminateProgram()
;_____ end programm _____________________________________________________________________
;_______________________________________________________________________________________



Function ChoisePlemea()
	FlushMouse 
	ViborPlemeni_in_Progress()
	Screen=1
	ClearScreens() 
End Function

Function IntroGorod()
	Gorod_in_Progress()
	ClearScreens() 
End Function

Function Battle()

	ClearScreens() 
End Function

Function IntroBattle()

	ClearScreens() 
End Function

Function IntroScreen()
;	MoveMouse 400,300
	Nachati_Igru = False 
        For q= 0 To Rand(8,30)
	InitList()
	Next 
	
	Repeat	
	mx# = MouseX() :  my# = MouseY()
		Cls
		DrawImage Start_Fon,0,0
		DrawImage Start_Menu, 450 , 0
		
	;	Rect 455,270,310,36,0
		Color 0,255,255
		
		If RectsOverlap (455,270,310,36, MouseX() ,MouseY(),1,1)  Then 			
			Rect 455,270,310,36,0	
			If MouseDown(1)  Then TerminateProgram()			
		EndIf 

		If RectsOverlap (455,30,310,36, MouseX() ,MouseY(),1,1)  Then 	
			Rect 455,30,310,36,0
			If MouseDown(1) Then Nachati_Igru = True			
		EndIf 
				
		DrawList()
		DrawImage Cursor  ,mx#,my#
		Flip
		If KeyDown(1) Then TerminateProgram()
        Until  Nachati_Igru = True 
	FlushMouse
	Delete Each ListData
	ClearScreens()
End Function

Function Button_Vihod()
	DrawImage Vihod, 700 , 550
	DrawImage Cursor_game ,mx#,my#	
	If  ImagesCollide (Vihod, 700 , 550,0,Cursor_game ,mx#,my#,0) And MouseHit(1)=True Then 
	Screen =1  
	 FlushMouse 
	EndIf 
End Function

Function ClearScreens()
	SetBuffer BackBuffer()
	Cls
End Function

Function InitList()
	CreateList				= New ListData
	CreateList\xposList 			= Rand(2,798)
	CreateList\yposList    		= Rand(-80,-520)
	CreateList\speedList     		= Rnd(0.5,1.3)
	CreateList\animframeList  	= Rand(8)
End Function

Function DrawList()
	    For CreateList = Each ListData
		        If  CreateList <> Null Then 
				    CreateList\animframeList = CreateList\animframeList + 1 	
				    If 	CreateList\animframeList>=8 Then 	CreateList\animframeList = 0
				
			CreateList\yposList = CreateList\yposList + CreateList\speedList
			If CreateList\yposList> -9 Then 
				DrawImage Star ,CreateList\xposList,CreateList\yposList,CreateList\animframeList ;frmSparks ;   
			EndIf 
			
			If CreateList\yposList >= 609 Then 
				CreateList\xposList 			= Rand(2,798)
				CreateList\yposList    		= Rand(-80,-520)
				CreateList\speedList     		= Rnd(0.5,1.3)
				CreateList\animframeList  	= Rand(8)
			EndIf 
		EndIf 
	    Next 
End Function

Function TerminateProgram()
;	FreeSound 
	FreeImage Start_Menu
	FreeImage Star 
	FreeImage Start_Fon	
	FreeImage Gorod_Elf
;	FreeImage Gorod_Efov
	FreeImage Vihod
;	FreeImage Elf_Edinorog 
	Delete Each ListData
	
;	FreeImage trees 	
;	FreeImage zatravka 
;	FreeImage elf_lukcinik
;	FreeImage fon
	;Delete Each streliba
	Delete Each ButtonsGame
	
	Delete Each GorodMap
	Delete Each ButtonsGorod
	Delete Each Gruppa
	Delete Each Units
	FreeImage Gorodfon  
	FreeImage b1x
	FreeImage b2x
	End
End Function